
User Interface - Bug #2921

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

fix vertical placement of FILL-IN (editable or not)/LABEL/EDITOR text 

12/07/2015 08:17 AM - Constantin Asofiei

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Eugenie Lyzenko % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stabilization for GUI   

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 12/07/2015 08:18 AM - Constantin Asofiei

From #2704 note 12:

Vertical placement is still off by a few pixels... this is mostly related to drawing the text centered vertically. I think instead ascent/descent values

need to be used (especially when editable mode is on).

 

Vertical placement of text in GUI is not 100% accurate in Swing, and in Web client the vertical text is not centered correctly - we might need to

compute ascent/descent values for Web (or other means to center the text correctly).

#2 - 03/23/2016 04:59 PM - Greg Shah

- Target version changed from Milestone 12 to Milestone 16

#3 - 09/21/2016 11:15 AM - Greg Shah

Several other widgets are affected too, including buttons, radio-buttons and toggle-box (maybe this is already considered with labels).

#4 - 09/21/2016 11:37 AM - Greg Shah

See #3054-151 through #3054-161 for some examples in both web and swing.

#5 - 11/16/2016 12:23 PM - Greg Shah

- Target version changed from Milestone 16 to Cleanup and Stabilization for GUI

#6 - 03/18/2019 04:07 PM - Greg Shah

- Assignee set to Eugenie Lyzenko

#7 - 04/05/2019 12:56 PM - Eugenie Lyzenko

Starting to work on the issue. What are the planes for changes to apply? Create separate branch or I can upload to current 3811a branch?
https://proj.goldencode.com/issues/2704


If separate one, should I start the regression testing for 3811a and merge into trunk in case of no regressions found?

#8 - 04/05/2019 02:54 PM - Greg Shah

Use 3811a.

We are first trying to get 3750b into trunk ASAP.  We aren't changing trunk until then.

#9 - 04/05/2019 02:54 PM - Eugenie Lyzenko

Greg Shah wrote:

Use 3811a.

We are first trying to get 3750b into trunk ASAP.  We aren't changing trunk until then.

 

OK. Understood.

#10 - 04/05/2019 06:00 PM - Eugenie Lyzenko

- File text_vert_location_dis_4gl.jpg added

- File text_vert_location_en_4gl.jpg added

- Status changed from New to WIP

Two samples from 4GL to compare vertical text location:

Enabled widgets:
Disabled widgets:
#11 - 04/05/2019 07:27 PM - Eugenie Lyzenko

- File text_vert_location_en_fwd_web_3811a_20190405a.jpg added

- File text_vert_location_dis_fwd_web_3811a_20190405b.jpg added

Deviations found.

Swing:

disabled Fill-In text location is higher than expected(1 pixel)

Web, widgets enabled:

enabled Fill-In text location is higher than expected(1 pixel)

Label for Fill-In is higher than expected(1 pixel)

enabled Editor text location is higher than expected(1 pixel)

Label for Editor is higher than expected(1 pixel)

Static text and label for it is higher than expected(1 pixel)

Label for Toggle-box is higher than expected(1 pixel)

Label and cell text for Browse is higher than expected(1 pixel)

Label for Radio-set is higher than expected(1 pixel)

Label for Button is higher than expected(1 pixel)

Web, widgets disabled(in addition to issues found for enabled state):

disabled Fill-In text location is higher than expected(2 pixels)

The pictures for FWD Web client:

Enabled widgets:

 

Disabled widgets:
Excluding disabled fill-in content 1 pixel shift(in 4GL the fill-in disabling should shift the text 1 pixel down) the others deviations can be also explained

by text height mismatch for Web client. For the same font web client text is one pixel smaller. If we compute text Y coordinate based on text height

this can explain total 1 pixel wrong shift. This is the GUI driver dependent issue. While disabled Fill-in has GUI driver independent issue. Both types

will be fixed separately, independent will be first.
#12 - 04/05/2019 10:47 PM - Eugenie Lyzenko

Task branch 3811a has been updated for review to revision 11318.

This is the fix for GUI driver independent vertical text placement for disabled FILL-IN widget issue. The text in entry field need to be shifted 2 pixels

down comparing to enabled.

The next part to fix is GUI dependent issue with text 1 pixel placement/height deviation for GUI Web driver. Need to investigate if the our text

height/vertical starting point is fine for Web driver JS code. Continue working.

#13 - 04/08/2019 10:39 AM - Eugenie Lyzenko

- File 2921_text_vert_location_en_fwd_20190408a.jpg added

- File 2921_text_vert_location_dis_fwd_20190408b.jpg added

Task branch 3811a has been updated for review to revision 11320.

This is the fix for GUI Web driver text vertical placement mismatch. Also I have found for some widgets FWD underlines the first letter of the label

when it should not. Also fixed. So the pictures in FWD are now:

Web client, enabled widgets.

 

Web client, disabled widgets.
#14 - 04/08/2019 10:40 AM - Eugenie Lyzenko

- Status changed from WIP to Review

- % Done changed from 0 to 100
Looks completed, need review and probably more screen to check the consistency.

#15 - 04/08/2019 03:46 PM - Greg Shah

Code Review Task Branch 3811a Revision 11320

The changes look quite good.  Some feedback:

1. I would like common code for the implementation of the edit*() methods since the only implementation difference is related to the widget type in the

error message.  I see that we can't use default methods of SelectableText because of the lack of backing for getId() and the type name.  And I

definitely don't want this code in GenericWidget.  How about moving the implementation to a clipboard helper class?

2. By convention, message types sent from JS UP to Java (like MSG_CLIPBOARD_SOFT_PASTE_READY) should be in the "lower range" of the

codes where the most significant bit is 0 (0x00 instead of 0x80).  The Java to JS message types are kept in the upper range.

3. CommonWidget needs a history entry.

Hynek/Constantin: Please review.

#16 - 04/08/2019 05:02 PM - Eugenie Lyzenko

Greg Shah wrote:

Code Review Task Branch 3811a Revision 11320

The changes look quite good.  Some feedback:

1. I would like common code for the implementation of the edit*() methods since the only implementation difference is related to the widget type

in the error message.  I see that we can't use default methods of SelectableText because of the lack of backing for getId() and the type name. 

And I definitely don't want this code in GenericWidget.  How about moving the implementation to a clipboard helper class?

 

OK. I'll upload reworked code later.

2. By convention, message types sent from JS UP to Java (like MSG_CLIPBOARD_SOFT_PASTE_READY) should be in the "lower range" of

the codes where the most significant bit is 0 (0x00 instead of 0x80).  The Java to JS message types are kept in the upper range.

3. CommonWidget needs a history entry.

 

Fixed.

Task branch 3811a has been updated for review to revision 11322.
#17 - 04/08/2019 05:40 PM - Eugenie Lyzenko

Greg Shah wrote:

Code Review Task Branch 3811a Revision 11320

The changes look quite good.  Some feedback:

1. I would like common code for the implementation of the edit*() methods since the only implementation difference is related to the widget type

in the error message.  I see that we can't use default methods of SelectableText because of the lack of backing for getId() and the type name. 

And I definitely don't want this code in GenericWidget.  How about moving the implementation to a clipboard helper class?

 

Planning to introduce new class p2j/ui/ClipboardHelper. The currently existed p2j/util/ClipboardManager is for some other goals comparing to what we

need here.

#18 - 04/08/2019 06:59 PM - Eugenie Lyzenko

Greg Shah wrote:

Code Review Task Branch 3811a Revision 11320

The changes look quite good.  Some feedback:

1. I would like common code for the implementation of the edit*() methods since the only implementation difference is related to the widget type

in the error message.  I see that we can't use default methods of SelectableText because of the lack of backing for getId() and the type name. 

And I definitely don't want this code in GenericWidget.  How about moving the implementation to a clipboard helper class?

 

Implemented in 3811a revision 11323.

#19 - 04/09/2019 07:57 PM - Eugenie Lyzenko

- Status changed from Review to Test

As part of the 3811a the changes passed regression testing. So it is in good shape for further rebase/commit when necessary.

#20 - 05/01/2019 10:17 AM - Greg Shah

- Status changed from Test to Closed
Branch 3811a was merged to trunk as revision 11303.
